import com.imptt.proptt.publicgw.plugins.V1.*;
import java.sql.*;

public class PublicGWPlugin1Sample implements IPublicGWPlugin
{
	String myId = "user2@imptt.com";
	ICallback cbObject = null;
	public int getInterfaceVersion()
	{
		System.out.println("PublicGWPlugin1Sample::getInterfaceVersion");
		return INTERFACE_VERSION;
	}
	
	public int getType()
	{
		System.out.println("PublicGWPlugin1Sample::getType");
		return TYPE_GENERAL_PLUGIN;
	}
	
	public void setCallback(ICallback cbObject)
	{
		System.out.println("PublicGWPlugin1Sample::setCallback cbObject="+cbObject);
		this.cbObject = cbObject;
	}
	
	public boolean initialize(String arg)
	{
		System.out.println("PublicGWPlugin1Sample::initialize arg="+arg);
		Connection conn = cbObject.getDBConnection();
		if(conn != null)
		{
			int dbSchemaVersion = 0;
			Statement stmt = null;
			try 
			{
				stmt = conn.createStatement();
				String sqlStr = "SELECT TextValue FROM TB_Setup WHERE TextKey='db.schema.version'";
				ResultSet rs = stmt.executeQuery(sqlStr);
				if(rs.next())
				{
					dbSchemaVersion = rs.getInt(1);
				}
			}
			catch (Exception e)
			{
				System.out.println(e.getMessage());
			}
			if ( stmt != null ) try { stmt.close(); }catch (Exception e){}
			System.out.println("PublicGWPlugin1Sample::initialize dbSchemaVersion="+dbSchemaVersion);
		}
		if(cbObject!=null) cbObject.OnInitialized();

		PTTUser user = new PTTUser();
		user.strID = myId;
		cbObject.login(user);
		return true;
	}
	

	//events
	public void OnLogin(PTTUser user)
	{
		System.out.println("PublicGWPlugin1Sample::OnLogin userId="+user.strID);
		if(user.strID.equals(myId)) {
			PTTChannel channel = new PTTChannel();
			channel.nID=56;
			cbObject.join(user, channel);
		}
	}
	
	public void OnLogout(PTTUser user, boolean byDuplication)
	{
		System.out.println("PublicGWPlugin1Sample::OnLogout userId="+user.strID+", byDuplication="+byDuplication);
	}
	
	public void OnJoined(PTTUser user, PTTChannel channel, PTTUser joinedUser)
	{
		System.out.println("PublicGWPlugin1Sample::OnJoined userId="+user.strID+", channel="+channel.nID+", joinedUser="+joinedUser.strID);
		if(joinedUser.strID.equals(myId)) {
			cbObject.lock(user, channel, 1.0f, 1.0f);
		}
	}
	
	public void OnLeaved(PTTUser user, PTTChannel channel, PTTUser leavedUser)
	{
		System.out.println("PublicGWPlugin1Sample::OnLeaved userId="+user.strID+", channel="+channel.nID+", leavedUser="+leavedUser.strID);
	}
	
	public void OnLocked(PTTUser user, PTTChannel channel, PTTUser lockUser, int lockIndex, int mediaProfileId, String userLocation, String audioCodec, String videoCodec, String jsonParams)
	{
		System.out.println("PublicGWPlugin1Sample::OnLocked userId="+user.strID+", channel="+channel.nID+", lockUser="+lockUser.strID+", lockIndex="+lockIndex);
		if(lockUser.strID.equals(myId)) {
			byte[] waveFrame = new byte[320];
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
			cbObject.sendAudioPTT(user, channel, waveFrame, 0, 320);
		}
	}
	
	public void OnUnlocked(PTTUser user, PTTChannel channel, PTTUser unlockUser, int lockIndex)
	{
		System.out.println("PublicGWPlugin1Sample::OnUnlocked userId="+user.strID+", channel="+channel.nID+", unlockUser="+unlockUser.strID+", lockIndex="+lockIndex);
		if(unlockUser.strID.equals(myId)) {
			cbObject.sendMesssage(user, channel, "1234");
			cbObject.sendCustomMesssage(user, channel, 1, "NDMyMQ==");
			cbObject.sendSOS(user, channel, 1.0f, 1.0f);
			cbObject.updateLocation(user, 2.0f, 2.0f);
		}
	}
	
	
	public void OnAudioPTTReceived(PTTUser user, PTTChannel channel, int lockIndex, int timestamp, byte[] waveFrame, int offset, int length)
	{
		System.out.println("PublicGWPlugin1Sample::OnAudioPTTReceived userId="+user.strID+", channel="+channel.nID+", lockIndex="+lockIndex);
	}
	
	public void OnVideoPTTReceived(PTTUser user, PTTChannel channel, int lockIndex, int timestamp, byte[] jpegFrame, int offset, int length)
	{
		System.out.println("PublicGWPlugin1Sample::OnVideoPTTReceived userId="+user.strID+", channel="+channel.nID+", lockIndex="+lockIndex);
	}
	
	public void OnMessageReceived(PTTUser user, PTTChannel channel, PTTUser sentUser, String message)
	{
		System.out.println("PublicGWPlugin1Sample::OnMessageReceived userId="+user.strID+", channel="+channel.nID+", sentUser="+sentUser.strID+", message="+message);
	}
	
	public void OnCustomMessageReceived(PTTUser user, PTTChannel channel, PTTUser sentUser, int messageId, String base64Message)
	{
		System.out.println("PublicGWPlugin1Sample::OnCustomMessageReceived userId="+user.strID+", channel="+channel.nID+", sentUser="+sentUser.strID);
	}
	
	public void OnSOSReceived(PTTUser user, PTTChannel channel, PTTUser sentUser, String userLocation)
	{
		System.out.println("PublicGWPlugin1Sample::OnSOSReceived userId="+user.strID+", channel="+channel.nID+", sentUser="+sentUser.strID);
	}
	
	
	public void OnVideoShared(PTTUser user, PTTChannel channel, PTTUser sharedUser, int videoChannelId, String serverIP, int serverPort, boolean useSSL, String token, String jsonParams)
	{
		System.out.println("PublicGWPlugin1Sample::OnVideoShared userId="+user.strID+", channel="+channel.nID+", sharedUser="+sharedUser.strID+", videoChannelId="+videoChannelId);
	}
	
	public void OnVideoUnshared(PTTUser user, PTTChannel channel, PTTUser unsharedUser, int videoChannelId)
	{
		System.out.println("PublicGWPlugin1Sample::OnVideoUnshared userId="+user.strID+", channel="+channel.nID+", unsharedUser="+unsharedUser.strID+", videoChannelId="+videoChannelId);
	}
	
	
	public void OnFileShared(PTTUser user, PTTChannel channel, PTTUser sharedUser, int fileChannelId, String serverIP, int serverPort, boolean useSSL, String token, String jsonParams)
	{
		System.out.println("PublicGWPlugin1Sample::OnFileShared userId="+user.strID+", channel="+channel.nID+", sharedUser="+sharedUser.strID+", fileChannelId="+fileChannelId);
	}
	
	public void OnFileUnshared(PTTUser user, PTTChannel channel, PTTUser unsharedUser, int fileChannelId)
	{
		System.out.println("PublicGWPlugin1Sample::OnFileUnshared userId="+user.strID+", channel="+channel.nID+", unsharedUser="+unsharedUser.strID+", fileChannelId="+fileChannelId);
	}
	

	public void OnError(int errCode, String jsonParams)
	{
		System.out.println("PublicGWPlugin1Sample::OnError errCode="+errCode+", jsonParams="+jsonParams);
	}
	
	public void OnExtenedEvent(String cmdName, String jsonParams)
	{
		System.out.println("PublicGWPlugin1Sample::OnExtenedEvent cmdName="+cmdName+", jsonParams="+jsonParams);
	}
		
}
